package com.gic.cloud.data.hook.service.deal.queryfilter;

import com.gic.api.base.commons.Page;
import com.gic.cloud.data.hook.api.dto.FilterQueryDataDTO;
import com.gic.cloud.data.hook.api.enums.QueryFilterCodeEnum;
import com.gic.cloud.data.hook.service.deal.QueryFilterContext;
import com.gic.cloud.data.hook.service.entity.QueryFilterInfo;
import com.gic.enterprise.api.service.StoreService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class StoreNameQueryNoPageFilter extends StoreNameQueryFilter {

    @Override
    public boolean checkFilter(QueryFilterContext context) {
        QueryFilterInfo queryFilterInfo = context.getQueryFilterInfo();
        if (null == queryFilterInfo||queryFilterInfo.getFilterCode()==null) {
            return false;
        }
        return queryFilterInfo.getFilterCode().equals(QueryFilterCodeEnum.STORE_NAME_NO_PAGE.getCode());
    }

    @Override
    public Page<FilterQueryDataDTO> pageQueryData(QueryFilterContext context) {
        context.setPageSize(9999);
        return super.pageQueryData(context);
    }

    @Override
    public List<FilterQueryDataDTO> listBackByItems(QueryFilterContext context) {
        return super.listBackByItems(context);
    }
}
